blob: 378e443300ffc1b7ff6537f6b99d89cdce364da7 [file] [log] [blame]
Ollie Lho184a4042005-11-26 21:55:36 +00001#
Uwe Hermannf78cff12009-06-12 14:05:25 +00002# This file is part of the flashrom project.
3#
4# Copyright (C) 2005 coresystems GmbH <stepan@coresystems.de>
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +00005# Copyright (C) 2009,2010,2012 Carl-Daniel Hailfinger
Uwe Hermannf78cff12009-06-12 14:05:25 +00006#
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; version 2 of the License.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +000016
Thomas Heijligen90fa8152021-09-25 13:39:42 +020017include Makefile.include
18
Ollie Lho184a4042005-11-26 21:55:36 +000019PROGRAM = flashrom
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +000020
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000021###############################################################################
22# Defaults for the toolchain.
23
24# If you want to cross-compile, just run e.g.
25# make CC=i586-pc-msdosdjgpp-gcc
26# You may have to specify STRIP/AR/RANLIB as well.
Carl-Daniel Hailfingerb7bce8a2012-08-14 21:36:11 +000027#
28# Note for anyone editing this Makefile: gnumake will happily ignore any
29# changes in this Makefile to variables set on the command line.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000030STRIP ?= strip
Thomas Heijligenf579bba2021-10-12 12:48:01 +020031STRIP_ARGS = -s
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000032INSTALL = install
Paul Fox05dfbe62009-06-16 21:08:06 +000033DIFF = diff
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000034PREFIX ?= /usr/local
Uwe Hermann56b2cb02009-05-21 15:59:58 +000035MANDIR ?= $(PREFIX)/share/man
Nico Huber9e2dc2f2018-12-23 22:00:47 +010036CFLAGS ?= -Os -Wall -Wextra -Wno-unused-parameter -Wshadow -Wmissing-prototypes -Wwrite-strings
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +000037EXPORTDIR ?= .
Patrick Georgi97bc95c2011-03-08 07:17:44 +000038RANLIB ?= ranlib
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000039PKG_CONFIG ?= pkg-config
40BUILD_DETAILS_FILE ?= build_details.txt
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000041
Stefan Taunerfd0d4132012-09-25 21:24:55 +000042# The following parameter changes the default programmer that will be used if there is no -p/--programmer
43# argument given when running flashrom. The predefined setting does not enable any default so that every
44# user has to declare the programmer he wants to use on every run. The rationale for this to be not set
45# (to e.g. the internal programmer) is that forgetting to specify this when working with another programmer
46# easily puts the system attached to the default programmer at risk (e.g. you want to flash coreboot to another
47# system attached to an external programmer while the default programmer is set to the internal programmer, and
48# you forget to use the -p parameter. This would (try to) overwrite the existing firmware of the computer
49# running flashrom). Please do not enable this without thinking about the possible consequences. Possible
Thomas Heijligen84e9c912021-06-01 16:22:14 +020050# values can be found when running 'flashrom --list-supported' under the 'Supported programmers' section.
51CONFIG_DEFAULT_PROGRAMMER_NAME ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000052# The following adds a default parameter for the default programmer set above (only).
Thomas Heijligen84e9c912021-06-01 16:22:14 +020053CONFIG_DEFAULT_PROGRAMMER_ARGS ?=
Stefan Tauner265fcac2014-06-02 00:12:23 +000054# Example: compiling with
Thomas Heijligen84e9c912021-06-01 16:22:14 +020055# make CONFIG_DEFAULT_PROGRAMMER_NAME=serprog CONFIG_DEFAULT_PROGRAMMER_ARGS="dev=/dev/ttyUSB0:1500000"
Stefan Tauner265fcac2014-06-02 00:12:23 +000056# would make executing './flashrom' (almost) equivialent to './flashrom -p serprog:dev=/dev/ttyUSB0:1500000'.
Christian Ruppertdb9d9f42009-05-14 14:17:07 +000057
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000058# If your compiler spits out excessive warnings, run make WARNERROR=no
59# You shouldn't have to change this flag.
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +000060WARNERROR ?= yes
61
62ifeq ($(WARNERROR), yes)
63CFLAGS += -Werror
64endif
65
Stefan Taunere37735a2015-01-26 22:03:35 +000066ifdef LIBS_BASE
Stefan Taunere37735a2015-01-26 22:03:35 +000067PKG_CONFIG_LIBDIR ?= $(LIBS_BASE)/lib/pkgconfig
Stefan Tauner45207062016-02-19 08:17:24 +000068override CPPFLAGS += -I$(LIBS_BASE)/include
69override LDFLAGS += -L$(LIBS_BASE)/lib -Wl,-rpath -Wl,$(LIBS_BASE)/lib
Stefan Taunere37735a2015-01-26 22:03:35 +000070endif
Stefan Taunerbe62d3f2015-01-10 09:32:44 +000071
Stefan Taunerbfb067b2016-01-07 18:13:07 +000072ifeq ($(CONFIG_STATIC),yes)
Stefan Tauner45207062016-02-19 08:17:24 +000073override PKG_CONFIG += --static
74override LDFLAGS += -static
Stefan Taunerbfb067b2016-01-07 18:13:07 +000075endif
76
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000077# Set LC_ALL=C to minimize influences of the locale.
78# However, this won't work for the majority of relevant commands because they use the $(shell) function and
Martin Rothf6c1cb12022-03-15 10:55:25 -060079# GNU make does not relay variables exported within the makefile to their environment.
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000080LC_ALL=C
81export LC_ALL
82
Stefan Tauner3f73ffe2016-01-07 17:45:59 +000083dummy_for_make_3_80:=$(shell printf "Build started on %s\n\n" "$$(date)" >$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000084
85# Provide an easy way to execute a command, print its output to stdout and capture any error message on stderr
86# in the build details file together with the original stdout output.
Pyry Kontio89cc73b2020-07-06 12:57:35 +090087debug_shell = $(shell export LC_ALL=C ; { echo 'exec: export LC_ALL=C ; { $(subst ','\'',$(1)) ; }' >&2; \
88 { $(1) ; } | tee -a $(BUILD_DETAILS_FILE) ; echo >&2 ; } 2>>$(BUILD_DETAILS_FILE))
Stefan Tauner1ca7c7f2016-01-14 23:05:55 +000089
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +000090###############################################################################
Nico Huber7f898972021-06-27 13:30:50 +020091# Dependency handling.
92
93DEPENDS_ON_SERIAL := \
94 CONFIG_BUSPIRATE_SPI \
95 CONFIG_PONY_SPI \
96 CONFIG_SERPROG \
97
98DEPENDS_ON_BITBANG_SPI := \
Nico Huber29c68342021-06-27 14:34:16 +020099 CONFIG_DEVELOPERBOX_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200100 CONFIG_INTERNAL \
101 CONFIG_NICINTEL_SPI \
102 CONFIG_OGP_SPI \
103 CONFIG_PONY_SPI \
104 CONFIG_RAYER_SPI \
105
106DEPENDS_ON_LIBPCI := \
107 CONFIG_ATAHPT \
108 CONFIG_ATAPROMISE \
109 CONFIG_ATAVIA \
110 CONFIG_DRKAISER \
111 CONFIG_GFXNVIDIA \
112 CONFIG_INTERNAL \
113 CONFIG_IT8212 \
114 CONFIG_NIC3COM \
115 CONFIG_NICINTEL \
116 CONFIG_NICINTEL_EEPROM \
117 CONFIG_NICINTEL_SPI \
118 CONFIG_NICNATSEMI \
119 CONFIG_NICREALTEK \
120 CONFIG_OGP_SPI \
121 CONFIG_SATAMV \
122 CONFIG_SATASII \
123
124DEPENDS_ON_LIBUSB1 := \
125 CONFIG_CH341A_SPI \
126 CONFIG_DEDIPROG \
127 CONFIG_DEVELOPERBOX_SPI \
128 CONFIG_DIGILENT_SPI \
129 CONFIG_PICKIT2_SPI \
130 CONFIG_RAIDEN_DEBUG_SPI \
131 CONFIG_STLINKV3_SPI \
Jean THOMASe28d8e42022-10-11 17:54:30 +0200132 CONFIG_DIRTYJTAG_SPI \
Nico Huber7f898972021-06-27 13:30:50 +0200133
134DEPENDS_ON_LIBFTDI := \
135 CONFIG_FT2232_SPI \
136 CONFIG_USBBLASTER_SPI \
137
138DEPENDS_ON_LIBJAYLINK := \
139 CONFIG_JLINK_SPI \
140
Nico Hubera54f5a42021-06-27 14:27:41 +0200141
142ifeq ($(CONFIG_ENABLE_LIBUSB1_PROGRAMMERS), no)
143$(call disable_all,$(DEPENDS_ON_LIBUSB1))
144endif
145
146ifeq ($(CONFIG_ENABLE_LIBPCI_PROGRAMMERS), no)
147$(call disable_all,$(DEPENDS_ON_LIBPCI))
148endif
149
Nico Huber7f898972021-06-27 13:30:50 +0200150###############################################################################
Stefan Tauner037cd842013-08-25 00:10:56 +0000151# General OS-specific settings.
152# 1. Prepare for later by gathering information about host and target OS
153# 2. Set compiler flags and parameters according to OSes
154# 3. Likewise verify user-supplied CONFIG_* variables.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000155
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000156# HOST_OS is only used to work around local toolchain issues.
Stefan Tauner037cd842013-08-25 00:10:56 +0000157HOST_OS ?= $(shell uname)
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100158ifeq ($(findstring MINGW, $(HOST_OS)), MINGW)
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000159# Explicitly set CC = gcc on MinGW, otherwise: "cc: command not found".
160CC = gcc
161endif
Miklós Mártona75a2ed2018-01-30 20:25:00 +0100162
Thomas Heijligen323ad352021-10-26 11:26:32 +0200163CC_WORKING := $(call c_compile_test, Makefile.d/cc_test.c)
164
Thomas Heijligen282a9512021-10-12 13:30:06 +0200165# Determine the destination OS, architecture and endian
166# IMPORTANT: The following lines must be placed before TARGET_OS, ARCH or ENDIAN
167# is ever used (of course), but should come after any lines setting CC because
168# the lines below use CC itself.
Thomas Heijligen1e76dc82021-09-28 15:22:34 +0200169override TARGET_OS := $(call c_macro_test, Makefile.d/os_test.h)
Thomas Heijligen6efdfb32021-10-12 15:16:46 +0200170override ARCH := $(call c_macro_test, Makefile.d/arch_test.h)
Thomas Heijligen9a2787b2021-10-12 15:54:06 +0200171override ENDIAN := $(call c_macro_test, Makefile.d/endian_test.h)
Thomas Heijligen282a9512021-10-12 13:30:06 +0200172
Thomas Heijligen0bec7b22021-10-12 13:18:15 +0200173ifeq ($(TARGET_OS), $(filter $(TARGET_OS), FreeBSD OpenBSD DragonFlyBSD))
174override CPPFLAGS += -I/usr/local/include
175override LDFLAGS += -L/usr/local/lib
176endif
177
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000178ifeq ($(TARGET_OS), Darwin)
Stefan Tauner45207062016-02-19 08:17:24 +0000179override CPPFLAGS += -I/opt/local/include -I/usr/local/include
180override LDFLAGS += -L/opt/local/lib -L/usr/local/lib
Stefan Reinauerf79edb92009-01-26 01:23:31 +0000181endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000182
Stefan Taunerc65b8552013-09-12 15:48:39 +0000183ifeq ($(TARGET_OS), NetBSD)
Nico Huberc0e1c4b2022-12-13 21:55:22 +0000184# Needs special `pciutils/pci.h` for older NetBSD packages
185PCIUTILS_PCI_H := $(shell [ -f /usr/pkg/include/pciutils/pci.h ] && echo -DPCIUTILS_PCI_H)
186override CPPFLAGS += -I/usr/pkg/include $(PCIUTILS_PCI_H)
Stefan Tauner45207062016-02-19 08:17:24 +0000187override LDFLAGS += -L/usr/pkg/lib
Stefan Taunerc65b8552013-09-12 15:48:39 +0000188endif
189
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000190ifeq ($(TARGET_OS), DOS)
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000191EXEC_SUFFIX := .exe
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000192# DJGPP has odd uint*_t definitions which cause lots of format string warnings.
Stefan Tauner45207062016-02-19 08:17:24 +0000193override CFLAGS += -Wno-format
Stefan Tauner449abe22013-09-11 23:34:57 +0000194LIBS += -lgetopt
Nico Huberba681962021-06-27 13:39:23 +0200195# Missing serial support.
196$(call mark_unsupported,$(DEPENDS_ON_SERIAL))
197# Libraries not available for DOS
198$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000199endif
Ollie Lho184a4042005-11-26 21:55:36 +0000200
Thomas Heijligen847d94b2021-10-12 17:38:01 +0200201ifeq ($(TARGET_OS), $(filter $(TARGET_OS), MinGW Cygwin))
202FEATURE_CFLAGS += -D'IS_WINDOWS=1'
203else
204FEATURE_CFLAGS += -D'IS_WINDOWS=0'
205endif
206
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000207# FIXME: Should we check for Cygwin/MSVC as well?
208ifeq ($(TARGET_OS), MinGW)
209EXEC_SUFFIX := .exe
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000210# MinGW doesn't have the ffs() function, but we can use gcc's __builtin_ffs().
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000211FLASHROM_CFLAGS += -Dffs=__builtin_ffs
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000212# Some functions provided by Microsoft do not work as described in C99 specifications. This macro fixes that
Stefan Tauner23e10b82016-01-23 16:16:49 +0000213# for MinGW. See http://sourceforge.net/p/mingw-w64/wiki2/printf%20and%20scanf%20family/ */
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000214FLASHROM_CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100215
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000216# For now we disable all PCI-based programmers on Windows/MinGW (no libpci).
Nico Huberca621782021-06-27 13:53:49 +0200217$(call mark_unsupported,$(DEPENDS_ON_LIBPCI))
218# And programmers that need raw access.
219$(call mark_unsupported,CONFIG_RAYER_SPI)
Uwe Hermannd5e85d62011-07-03 19:44:12 +0000220
Nico Huberca621782021-06-27 13:53:49 +0200221else # No MinGW
222
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100223# NI USB-845x only supported on Windows at the moment
Nico Huberca621782021-06-27 13:53:49 +0200224$(call mark_unsupported,CONFIG_NI845X_SPI)
225
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100226endif
227
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000228ifeq ($(TARGET_OS), libpayload)
Stefan Tauner8e19b042013-08-28 09:55:04 +0000229ifeq ($(MAKECMDGOALS),)
230.DEFAULT_GOAL := libflashrom.a
231$(info Setting default goal to libflashrom.a)
232endif
Carl-Daniel Hailfingera8da2242012-08-15 23:06:32 +0000233FLASHROM_CFLAGS += -DSTANDALONE
Nico Huber71331032021-06-27 14:00:39 +0200234$(call mark_unsupported,CONFIG_DUMMY)
Stefan Taunere0168262016-02-21 11:18:24 +0000235# libpayload does not provide the romsize field in struct pci_dev that the atapromise code requires.
Nico Huber71331032021-06-27 14:00:39 +0200236$(call mark_unsupported,CONFIG_ATAPROMISE)
Carl-Daniel Hailfinger11990da2013-07-13 23:21:05 +0000237# Bus Pirate, Serprog and PonyProg are not supported with libpayload (missing serial support).
Nico Huber71331032021-06-27 14:00:39 +0200238$(call mark_unsupported,CONFIG_BUSPIRATE_SPI CONFIG_SERPROG CONFIG_PONY_SPI)
Daniel Thompson45e91a22018-06-04 13:46:29 +0100239# Dediprog, Developerbox, USB-Blaster, PICkit2, CH341A and FT2232 are not supported with libpayload (missing libusb support).
Nico Huber71331032021-06-27 14:00:39 +0200240$(call mark_unsupported,$(DEPENDS_ON_LIBUSB1) $(DEPENDS_ON_LIBFTDI) $(DEPENDS_ON_LIBJAYLINK))
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000241endif
242
Nico Huberdc8e54a2021-06-27 14:17:34 +0200243# Android is handled internally as separate OS, but it supports about the same drivers as Linux.
Thomas Heijligen485d2cd2021-10-19 16:14:55 +0200244ifneq ($(TARGET_OS), $(filter $(TARGET_OS), Linux Android))
Nico Huberdc8e54a2021-06-27 14:17:34 +0200245$(call mark_unsupported,CONFIG_LINUX_MTD CONFIG_LINUX_SPI)
246$(call mark_unsupported,CONFIG_MSTARDDC_SPI)
Carl-Daniel Hailfinger601f4cd2016-02-28 22:04:51 +0000247endif
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000248
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000249ifeq ($(TARGET_OS), Android)
Nico Huberdc8e54a2021-06-27 14:17:34 +0200250# Android on x86 (currently) does not provide raw PCI port I/O operations.
251$(call mark_unsupported,CONFIG_RAYER_SPI)
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000252endif
253
Nico Huberc8801732017-12-01 18:19:43 +0000254# Disable the internal programmer on unsupported architectures (everything but x86 and mipsel)
Thomas Heijligen485d2cd2021-10-19 16:14:55 +0200255ifneq ($(ARCH)-little, $(filter $(ARCH), x86 mips)-$(ENDIAN))
Nico Huber8945b812021-06-27 14:24:53 +0200256$(call mark_unsupported,CONFIG_INTERNAL)
Nico Huberc8801732017-12-01 18:19:43 +0000257endif
258
Thomas Heijligend6d96c12021-10-12 16:47:43 +0200259ifeq ($(ENDIAN), little)
260FEATURE_CFLAGS += -D'__FLASHROM_LITTLE_ENDIAN__=1'
261endif
262ifeq ($(ENDIAN), big)
263FEATURE_CFLAGS += -D'__FLASHROM_BIG_ENDIAN__=1'
264endif
265
Stefan Taunerfb2d77c2015-02-10 08:03:10 +0000266# PCI port I/O support is unimplemented on PPC/MIPS/SPARC and unavailable on ARM.
David Hendricksb286da72012-02-13 00:35:35 +0000267# Right now this means the drivers below only work on x86.
268ifneq ($(ARCH), x86)
Nico Huber8945b812021-06-27 14:24:53 +0200269$(call mark_unsupported,CONFIG_NIC3COM CONFIG_NICREALTEK CONFIG_NICNATSEMI)
270$(call mark_unsupported,CONFIG_RAYER_SPI CONFIG_ATAHPT CONFIG_ATAPROMISE)
271$(call mark_unsupported,CONFIG_SATAMV)
Uwe Hermann21b10c62011-07-29 12:13:01 +0000272endif
273
Nico Huber8945b812021-06-27 14:24:53 +0200274# Additionally disable all drivers needing raw access (memory, PCI, port I/O)
275# on architectures with unknown raw access properties.
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000276# Right now those architectures are alpha hppa m68k sh s390
Thomas Heijligen485d2cd2021-10-19 16:14:55 +0200277ifneq ($(ARCH), $(filter $(ARCH), x86 mips ppc arm sparc arc))
Nico Huber8945b812021-06-27 14:24:53 +0200278$(call mark_unsupported,CONFIG_GFXNVIDIA CONFIG_SATASII CONFIG_ATAVIA)
279$(call mark_unsupported,CONFIG_DRKAISER CONFIG_NICINTEL CONFIG_NICINTEL_SPI)
280$(call mark_unsupported,CONFIG_NICINTEL_EEPROM CONFIG_OGP_SPI CONFIG_IT8212)
Carl-Daniel Hailfinger8d0d53f2016-02-25 20:10:26 +0000281endif
282
Thomas Heijligen433dc1c2021-10-12 17:58:35 +0200283ifeq ($(TARGET_OS), $(filter $(TARGET_OS), Linux Darwin NetBSD OpenBSD))
284FEATURE_CFLAGS += -D'USE_IOPL=1'
285else
286FEATURE_CFLAGS += -D'USE_IOPL=0'
287endif
288
289ifeq ($(TARGET_OS), $(filter $(TARGET_OS), FreeBSD FreeBSD-glibc DragonFlyBSD))
290FEATURE_CFLAGS += -D'USE_DEV_IO=1'
291else
292FEATURE_CFLAGS += -D'USE_DEV_IO=0'
293endif
294
295ifeq ($(TARGET_OS), $(filter $(TARGET_OS), Hurd))
296FEATURE_CFLAGS += -D'USE_IOPERM=1'
297else
298FEATURE_CFLAGS += -D'USE_IOPERM=0'
299endif
300
301
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000302###############################################################################
303# Flash chip drivers and bus support infrastructure.
304
Stefan Tauner4404f732013-09-12 08:28:56 +0000305CHIP_OBJS = jedec.o stm50.o w39.o w29ee011.o \
Carl-Daniel Hailfingera8cf3622014-08-08 08:33:01 +0000306 sst28sf040.o 82802ab.o \
Paul Kocialkowski80ae14e2018-01-15 01:07:46 +0300307 sst49lfxxxc.o sst_fwhub.o edi.o flashchips.o spi.o spi25.o spi25_statusreg.o \
Nikolai Artemievc9feb1b2021-10-21 01:35:13 +1100308 spi95.o opaque.o sfdp.o en29lv640b.o at45db.o \
309 writeprotect.o writeprotect_ranges.o
Sean Nelson5d134642009-12-24 16:54:21 +0000310
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000311###############################################################################
312# Library code.
Sean Nelson5d134642009-12-24 16:54:21 +0000313
Thomas Heijligenbbfacff2021-03-31 20:40:01 +0200314LIB_OBJS = libflashrom.o layout.o flashrom.o udelay.o programmer.o programmer_table.o helpers.o ich_descriptors.o fmap.o
Sean Nelson5d134642009-12-24 16:54:21 +0000315
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000316###############################################################################
317# Frontend related stuff.
Ollie Lho184a4042005-11-26 21:55:36 +0000318
Stefan Tauner9b32de92014-08-08 23:52:33 +0000319CLI_OBJS = cli_classic.o cli_output.o cli_common.o print.o
Ollie Lho184a4042005-11-26 21:55:36 +0000320
Stefan Taunerfa25bc32017-10-04 03:47:26 +0200321# versioninfo.inc stores metadata required to build a packaged flashrom. It is generated by the export rule and
322# imported below. If versioninfo.inc is not found and the variables are not defined by the user, the info will
323# be obtained using util/getrevision.sh, which is the common case during development.
324-include versioninfo.inc
Stefan Tauner5bf6b852017-10-04 03:46:51 +0200325VERSION ?= $(shell ./util/getrevision.sh --revision)
Stefan Tauner96209122017-10-01 16:41:35 +0200326MAN_DATE ?= $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +0000327
Stefan Tauner76347082016-11-27 17:45:49 +0100328SCMDEF := -D'FLASHROM_VERSION="$(VERSION)"'
Bernhard Walle201bde32008-01-21 15:24:22 +0000329
Stefan Tauner76347082016-11-27 17:45:49 +0100330# Inform user of the version string
Nico Huber26c2c4d2023-01-10 17:45:38 +0100331ifeq ($(filter branch tag,$(MAKECMDGOALS)), )
Stefan Tauner76347082016-11-27 17:45:49 +0100332$(info Replacing all version templates with $(VERSION).)
Nico Huber26c2c4d2023-01-10 17:45:38 +0100333endif
Stefan Taunerd5ff8452015-01-10 09:32:07 +0000334
Stefan Tauner037cd842013-08-25 00:10:56 +0000335###############################################################################
336# Default settings of CONFIG_* variables.
337
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000338# Always enable internal/onboard support for now.
339CONFIG_INTERNAL ?= yes
340
Stefan Tauner52b6e9d2013-04-01 00:46:05 +0000341# Always enable serprog for now.
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000342CONFIG_SERPROG ?= yes
343
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000344# RayeR SPIPGM hardware support
345CONFIG_RAYER_SPI ?= yes
346
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000347# PonyProg2000 SPI hardware support
348CONFIG_PONY_SPI ?= yes
349
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000350# Always enable 3Com NICs for now.
351CONFIG_NIC3COM ?= yes
352
Carl-Daniel Hailfingerbf3af292010-07-29 14:41:46 +0000353# Enable NVIDIA graphics cards. Note: write and erase do not work properly.
354CONFIG_GFXNVIDIA ?= yes
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000355
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000356# Always enable SiI SATA controllers for now.
357CONFIG_SATASII ?= yes
358
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000359# Highpoint (HPT) ATA/RAID controller support.
360# IMPORTANT: This code is not yet working!
361CONFIG_ATAHPT ?= no
362
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000363# VIA VT6421A LPC memory support
364CONFIG_ATAVIA ?= yes
365
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000366# Promise ATA controller support.
367CONFIG_ATAPROMISE ?= no
368
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000369# Always enable FT2232 SPI dongles for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000370CONFIG_FT2232_SPI ?= yes
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000371
James Lairdc60de0e2013-03-27 13:00:23 +0000372# Always enable Altera USB-Blaster dongles for now.
373CONFIG_USBBLASTER_SPI ?= yes
374
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000375# MSTAR DDC support needs more tests/reviews/cleanups.
376CONFIG_MSTARDDC_SPI ?= no
377
Justin Chevrier66e554b2015-02-08 21:58:10 +0000378# Always enable PICkit2 SPI dongles for now.
379CONFIG_PICKIT2_SPI ?= yes
380
Miklós Márton324929c2019-08-01 19:14:10 +0200381# Always enable STLink V3
382CONFIG_STLINKV3_SPI ?= yes
383
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000384# Always enable dummy tracing for now.
385CONFIG_DUMMY ?= yes
386
387# Always enable Dr. Kaiser for now.
388CONFIG_DRKAISER ?= yes
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000389
Joerg Fischer5665ef32010-05-21 21:54:07 +0000390# Always enable Realtek NICs for now.
391CONFIG_NICREALTEK ?= yes
392
Andrew Morganc29c2e72010-06-07 22:37:54 +0000393# Disable National Semiconductor NICs until support is complete and tested.
394CONFIG_NICNATSEMI ?= no
395
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000396# Always enable Intel NICs for now.
397CONFIG_NICINTEL ?= yes
398
Idwer Vollering004f4b72010-09-03 18:21:21 +0000399# Always enable SPI on Intel NICs for now.
400CONFIG_NICINTEL_SPI ?= yes
401
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000402# Always enable EEPROM on Intel NICs for now.
403CONFIG_NICINTEL_EEPROM ?= yes
404
Mark Marshall90021f22010-12-03 14:48:11 +0000405# Always enable SPI on OGP cards for now.
406CONFIG_OGP_SPI ?= yes
407
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000408# Always enable Bus Pirate SPI for now.
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000409CONFIG_BUSPIRATE_SPI ?= yes
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000410
Simon Glassae616512016-01-23 23:27:58 +0000411# Always enable Dediprog SF100 for now.
412CONFIG_DEDIPROG ?= yes
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000413
Daniel Thompson45e91a22018-06-04 13:46:29 +0100414# Always enable Developerbox emergency recovery for now.
415CONFIG_DEVELOPERBOX_SPI ?= yes
416
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000417# Always enable Marvell SATA controllers for now.
418CONFIG_SATAMV ?= yes
419
David Hendricksf9a30552015-05-23 20:30:30 -0700420# Enable Linux spidev and MTD interfaces by default. We disable them on non-Linux targets.
421CONFIG_LINUX_MTD ?= yes
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000422CONFIG_LINUX_SPI ?= yes
423
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000424# Always enable ITE IT8212F PATA controllers for now.
425CONFIG_IT8212 ?= yes
426
Urja Rannikko0870b022016-01-31 22:10:29 +0000427# Winchiphead CH341A
428CONFIG_CH341A_SPI ?= yes
429
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100430# Digilent Development board JTAG
431CONFIG_DIGILENT_SPI ?= yes
432
Jean THOMASe28d8e42022-10-11 17:54:30 +0200433# DirtyJTAG
434CONFIG_DIRTYJTAG_SPI ?= yes
435
Marc Schink3578ec62016-03-17 16:23:03 +0100436# Disable J-Link for now.
437CONFIG_JLINK_SPI ?= no
438
Nico Huber83d52072021-06-27 00:07:13 +0200439# National Instruments USB-845x is Windows only and needs a proprietary library.
440CONFIG_NI845X_SPI ?= no
441
Carl-Daniel Hailfinger6161ff12009-11-16 21:22:24 +0000442# Disable wiki printing by default. It is only useful if you have wiki access.
Uwe Hermann2db77a02010-06-04 17:07:39 +0000443CONFIG_PRINT_WIKI ?= no
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000444
Stefan Taunerf3503372016-02-26 23:51:21 +0000445# Disable all features if CONFIG_NOTHING=yes is given unless CONFIG_EVERYTHING was also set
446ifeq ($(CONFIG_NOTHING), yes)
447 ifeq ($(CONFIG_EVERYTHING), yes)
448 $(error Setting CONFIG_NOTHING=yes and CONFIG_EVERYTHING=yes does not make sense)
449 endif
450 $(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
451 $(if $(filter yes, $($(var))),\
452 $(eval $(var)=no)))
453endif
454
Patrick Georgiced7ab62015-01-19 19:52:34 +0000455# Enable all features if CONFIG_EVERYTHING=yes is given
456ifeq ($(CONFIG_EVERYTHING), yes)
457$(foreach var, $(filter CONFIG_%, $(.VARIABLES)),\
458 $(if $(filter no, $($(var))),\
459 $(eval $(var)=yes)))
460endif
461
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000462# Bitbanging SPI infrastructure, default off unless needed.
Nico Huber29c68342021-06-27 14:34:16 +0200463
464ifneq ($(call filter_deps,$(DEPENDS_ON_BITBANG_SPI)), )
Felix Singer4cbc1cb2022-07-22 23:23:28 +0200465override CONFIG_BITBANG_SPI = yes
466else
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000467CONFIG_BITBANG_SPI ?= no
468endif
Carl-Daniel Hailfinger9e3a6c42010-10-08 12:40:09 +0000469
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000470###############################################################################
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000471# Handle CONFIG_* variables that depend on others set (and verified) above.
472
473# The external DMI decoder (dmidecode) does not work in libpayload. Bail out if the internal one got disabled.
474ifeq ($(TARGET_OS), libpayload)
475ifeq ($(CONFIG_INTERNAL), yes)
476ifeq ($(CONFIG_INTERNAL_DMI), no)
477UNSUPPORTED_FEATURES += CONFIG_INTERNAL_DMI=no
478else
479override CONFIG_INTERNAL_DMI = yes
480endif
481endif
482endif
483
484# Use internal DMI/SMBIOS decoder by default instead of relying on dmidecode.
485CONFIG_INTERNAL_DMI ?= yes
486
487###############################################################################
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000488# Programmer drivers and programmer support infrastructure.
Stefan Tauner037cd842013-08-25 00:10:56 +0000489# Depending on the CONFIG_* variables set and verified above we set compiler flags and parameters below.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000490
Thomas Heijligen84e9c912021-06-01 16:22:14 +0200491ifdef CONFIG_DEFAULT_PROGRAMMER_NAME
492FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=&programmer_$(CONFIG_DEFAULT_PROGRAMMER_NAME)'
493else
494FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_NAME=NULL'
495endif
496
Stefan Tauner265fcac2014-06-02 00:12:23 +0000497FEATURE_CFLAGS += -D'CONFIG_DEFAULT_PROGRAMMER_ARGS="$(CONFIG_DEFAULT_PROGRAMMER_ARGS)"'
Stefan Taunerfd0d4132012-09-25 21:24:55 +0000498
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000499ifeq ($(CONFIG_INTERNAL), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000500FEATURE_CFLAGS += -D'CONFIG_INTERNAL=1'
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000501PROGRAMMER_OBJS += processor_enable.o chipset_enable.o board_enable.o cbtable.o internal.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000502ifeq ($(ARCH), x86)
Edward O'Callaghan2ab6bba2022-06-24 16:48:09 +1000503PROGRAMMER_OBJS += it87spi.o sb600spi.o amd_imc.o wbsio_spi.o mcp6x_spi.o
Nico Huber305f4172013-06-14 11:55:26 +0200504PROGRAMMER_OBJS += ichspi.o dmi.o
Sean Nelson4c6d3a42013-09-11 23:35:03 +0000505ifeq ($(CONFIG_INTERNAL_DMI), yes)
506FEATURE_CFLAGS += -D'CONFIG_INTERNAL_DMI=1'
507endif
Carl-Daniel Hailfinger91199a12011-07-07 06:59:18 +0000508else
509endif
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000510endif
511
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000512ifeq ($(CONFIG_SERPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000513FEATURE_CFLAGS += -D'CONFIG_SERPROG=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000514PROGRAMMER_OBJS += serprog.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000515NEED_SERIAL += CONFIG_SERPROG
516NEED_POSIX_SOCKETS += CONFIG_SERPROG
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000517endif
518
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000519ifeq ($(CONFIG_RAYER_SPI), yes)
520FEATURE_CFLAGS += -D'CONFIG_RAYER_SPI=1'
521PROGRAMMER_OBJS += rayer_spi.o
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000522NEED_RAW_ACCESS += CONFIG_RAYER_SPI
Carl-Daniel Hailfingere7fdd6e2010-07-21 10:26:01 +0000523endif
524
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000525ifeq ($(CONFIG_PONY_SPI), yes)
526FEATURE_CFLAGS += -D'CONFIG_PONY_SPI=1'
527PROGRAMMER_OBJS += pony_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000528NEED_SERIAL += CONFIG_PONY_SPI
Virgil-Adrian Teacada7c5452012-04-30 23:11:06 +0000529endif
530
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000531ifeq ($(CONFIG_BITBANG_SPI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000532FEATURE_CFLAGS += -D'CONFIG_BITBANG_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000533PROGRAMMER_OBJS += bitbang_spi.o
Carl-Daniel Hailfinger547872b2009-09-28 13:15:16 +0000534endif
535
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000536ifeq ($(CONFIG_NIC3COM), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000537FEATURE_CFLAGS += -D'CONFIG_NIC3COM=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000538PROGRAMMER_OBJS += nic3com.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000539endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000540
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000541ifeq ($(CONFIG_GFXNVIDIA), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000542FEATURE_CFLAGS += -D'CONFIG_GFXNVIDIA=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000543PROGRAMMER_OBJS += gfxnvidia.o
Uwe Hermann2bc98f62009-09-30 18:29:55 +0000544endif
545
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000546ifeq ($(CONFIG_SATASII), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000547FEATURE_CFLAGS += -D'CONFIG_SATASII=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000548PROGRAMMER_OBJS += satasii.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000549endif
550
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000551ifeq ($(CONFIG_ATAHPT), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000552FEATURE_CFLAGS += -D'CONFIG_ATAHPT=1'
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000553PROGRAMMER_OBJS += atahpt.o
Uwe Hermannddd5c9e2010-02-21 21:17:00 +0000554endif
555
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000556ifeq ($(CONFIG_ATAVIA), yes)
557FEATURE_CFLAGS += -D'CONFIG_ATAVIA=1'
558PROGRAMMER_OBJS += atavia.o
Jonathan Kollasch7f0f3fa2014-06-01 10:26:23 +0000559endif
560
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000561ifeq ($(CONFIG_ATAPROMISE), yes)
562FEATURE_CFLAGS += -D'CONFIG_ATAPROMISE=1'
563PROGRAMMER_OBJS += atapromise.o
Joseph C. Lehnerc2644a32016-01-16 23:45:25 +0000564endif
565
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000566ifeq ($(CONFIG_IT8212), yes)
567FEATURE_CFLAGS += -D'CONFIG_IT8212=1'
568PROGRAMMER_OBJS += it8212.o
Kyösti Mälkki72d42f82014-06-01 23:48:31 +0000569endif
570
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000571ifeq ($(CONFIG_FT2232_SPI), yes)
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000572# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000573FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_FT2232_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000574PROGRAMMER_OBJS += ft2232_spi.o
575endif
576
577ifeq ($(CONFIG_USBBLASTER_SPI), yes)
578# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000579FEATURE_CFLAGS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "-D'CONFIG_USBBLASTER_SPI=1'")
James Lairdc60de0e2013-03-27 13:00:23 +0000580PROGRAMMER_OBJS += usbblaster_spi.o
581endif
582
Justin Chevrier66e554b2015-02-08 21:58:10 +0000583ifeq ($(CONFIG_PICKIT2_SPI), yes)
584FEATURE_CFLAGS += -D'CONFIG_PICKIT2_SPI=1'
585PROGRAMMER_OBJS += pickit2_spi.o
Justin Chevrier66e554b2015-02-08 21:58:10 +0000586endif
587
Miklós Márton324929c2019-08-01 19:14:10 +0200588ifeq ($(CONFIG_STLINKV3_SPI), yes)
589FEATURE_CFLAGS += -D'CONFIG_STLINKV3_SPI=1'
590PROGRAMMER_OBJS += stlinkv3_spi.o
Miklós Márton324929c2019-08-01 19:14:10 +0200591endif
592
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000593ifeq ($(CONFIG_DUMMY), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000594FEATURE_CFLAGS += -D'CONFIG_DUMMY=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000595PROGRAMMER_OBJS += dummyflasher.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000596endif
597
598ifeq ($(CONFIG_DRKAISER), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000599FEATURE_CFLAGS += -D'CONFIG_DRKAISER=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000600PROGRAMMER_OBJS += drkaiser.o
Carl-Daniel Hailfinger4740c6f2009-09-16 10:09:21 +0000601endif
Carl-Daniel Hailfinger6be74112009-08-12 16:17:41 +0000602
Joerg Fischer5665ef32010-05-21 21:54:07 +0000603ifeq ($(CONFIG_NICREALTEK), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000604FEATURE_CFLAGS += -D'CONFIG_NICREALTEK=1'
Joerg Fischer5665ef32010-05-21 21:54:07 +0000605PROGRAMMER_OBJS += nicrealtek.o
Joerg Fischer5665ef32010-05-21 21:54:07 +0000606endif
607
Andrew Morganc29c2e72010-06-07 22:37:54 +0000608ifeq ($(CONFIG_NICNATSEMI), yes)
609FEATURE_CFLAGS += -D'CONFIG_NICNATSEMI=1'
610PROGRAMMER_OBJS += nicnatsemi.o
Andrew Morganc29c2e72010-06-07 22:37:54 +0000611endif
612
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000613ifeq ($(CONFIG_NICINTEL), yes)
614FEATURE_CFLAGS += -D'CONFIG_NICINTEL=1'
615PROGRAMMER_OBJS += nicintel.o
Carl-Daniel Hailfingerb713d2e2011-05-08 00:24:18 +0000616endif
617
Idwer Vollering004f4b72010-09-03 18:21:21 +0000618ifeq ($(CONFIG_NICINTEL_SPI), yes)
619FEATURE_CFLAGS += -D'CONFIG_NICINTEL_SPI=1'
620PROGRAMMER_OBJS += nicintel_spi.o
Idwer Vollering004f4b72010-09-03 18:21:21 +0000621endif
622
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000623ifeq ($(CONFIG_NICINTEL_EEPROM), yes)
624FEATURE_CFLAGS += -D'CONFIG_NICINTEL_EEPROM=1'
625PROGRAMMER_OBJS += nicintel_eeprom.o
Ricardo Ribalda Delgado2a41f0a2014-07-28 20:35:21 +0000626endif
627
Mark Marshall90021f22010-12-03 14:48:11 +0000628ifeq ($(CONFIG_OGP_SPI), yes)
629FEATURE_CFLAGS += -D'CONFIG_OGP_SPI=1'
630PROGRAMMER_OBJS += ogp_spi.o
Mark Marshall90021f22010-12-03 14:48:11 +0000631endif
632
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000633ifeq ($(CONFIG_BUSPIRATE_SPI), yes)
634FEATURE_CFLAGS += -D'CONFIG_BUSPIRATE_SPI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000635PROGRAMMER_OBJS += buspirate_spi.o
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000636NEED_SERIAL += CONFIG_BUSPIRATE_SPI
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000637endif
638
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000639ifeq ($(CONFIG_DEDIPROG), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000640FEATURE_CFLAGS += -D'CONFIG_DEDIPROG=1'
Carl-Daniel Hailfingerd38fac82010-01-19 11:15:48 +0000641PROGRAMMER_OBJS += dediprog.o
642endif
643
Daniel Thompson45e91a22018-06-04 13:46:29 +0100644ifeq ($(CONFIG_DEVELOPERBOX_SPI), yes)
645FEATURE_CFLAGS += -D'CONFIG_DEVELOPERBOX_SPI=1'
646PROGRAMMER_OBJS += developerbox_spi.o
Daniel Thompson45e91a22018-06-04 13:46:29 +0100647endif
648
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000649ifeq ($(CONFIG_SATAMV), yes)
650FEATURE_CFLAGS += -D'CONFIG_SATAMV=1'
651PROGRAMMER_OBJS += satamv.o
Carl-Daniel Hailfinger9a1105c2011-02-04 21:37:59 +0000652endif
653
David Hendricksf9a30552015-05-23 20:30:30 -0700654ifeq ($(CONFIG_LINUX_MTD), yes)
655# This is a totally ugly hack.
656FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_MTD_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_MTD=1'")
657PROGRAMMER_OBJS += linux_mtd.o
658endif
659
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000660ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner8868db32012-03-13 00:18:19 +0000661# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000662FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_SPI_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_LINUX_SPI=1'")
Carl-Daniel Hailfinger8541d232012-02-16 21:00:27 +0000663PROGRAMMER_OBJS += linux_spi.o
664endif
665
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000666ifeq ($(CONFIG_MSTARDDC_SPI), yes)
667# This is a totally ugly hack.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000668FEATURE_CFLAGS += $(call debug_shell,grep -q "LINUX_I2C_SUPPORT := yes" .features && printf "%s" "-D'CONFIG_MSTARDDC_SPI=1'")
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000669NEED_LINUX_I2C += CONFIG_MSTARDDC_SPI
Alexandre Boeglin80e64712014-12-20 20:25:19 +0000670PROGRAMMER_OBJS += mstarddc_spi.o
671endif
672
Urja Rannikko0870b022016-01-31 22:10:29 +0000673ifeq ($(CONFIG_CH341A_SPI), yes)
674FEATURE_CFLAGS += -D'CONFIG_CH341A_SPI=1'
675PROGRAMMER_OBJS += ch341a_spi.o
Urja Rannikko0870b022016-01-31 22:10:29 +0000676endif
677
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100678ifeq ($(CONFIG_DIGILENT_SPI), yes)
679FEATURE_CFLAGS += -D'CONFIG_DIGILENT_SPI=1'
680PROGRAMMER_OBJS += digilent_spi.o
Lubomir Rintelb2154e82018-01-14 17:35:33 +0100681endif
682
Jean THOMASe28d8e42022-10-11 17:54:30 +0200683ifeq ($(CONFIG_DIRTYJTAG_SPI), yes)
684FEATURE_CFLAGS += -D'CONFIG_DIRTYJTAG_SPI=1'
685PROGRAMMER_OBJS += dirtyjtag_spi.o
686endif
687
Marc Schink3578ec62016-03-17 16:23:03 +0100688ifeq ($(CONFIG_JLINK_SPI), yes)
Marc Schink3578ec62016-03-17 16:23:03 +0100689FEATURE_CFLAGS += -D'CONFIG_JLINK_SPI=1'
690PROGRAMMER_OBJS += jlink_spi.o
691endif
692
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100693ifeq ($(CONFIG_NI845X_SPI), yes)
694FEATURE_CFLAGS += -D'CONFIG_NI845X_SPI=1'
695
696ifeq ($(CONFIG_NI845X_LIBRARY_PATH),)
697# if the user did not specified the NI-845x headers/lib path
698# do a guess for both 32 and 64 bit Windows versions
699NI845X_LIBS += -L'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100700NI845X_INCLUDES += -I'${PROGRAMFILES}\National Instruments\NI-845x\MS Visual C'
Miklós Mártonfea5aa12021-07-27 14:29:16 +0200701
702# hack to access env variable containing brackets...
703PROGRAMFILES_X86DIR = $(shell env | sed -n "s/^PROGRAMFILES(X86)=//p")
704
705ifneq ($(PROGRAMFILES_X86DIR),)
706ifneq ($(PROGRAMFILES_X86DIR), ${PROGRAMFILES})
707NI845X_LIBS += -L'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
708NI845X_INCLUDES += -I'$(PROGRAMFILES_X86DIR)\National Instruments\NI-845x\MS Visual C'
709endif
710endif
711
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100712else
713NI845X_LIBS += -L'$(CONFIG_NI845X_LIBRARY_PATH)'
714NI845X_INCLUDES += -I'$(CONFIG_NI845X_LIBRARY_PATH)'
715endif
716
717FEATURE_CFLAGS += $(NI845X_INCLUDES)
718LIBS += -lni845x
719PROGRAMMER_OBJS += ni845x_spi.o
720endif
721
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000722ifneq ($(NEED_SERIAL), )
Thomas Heijligen140c1262021-09-27 15:12:26 +0200723LIB_OBJS += serial.o
724ifeq ($(TARGET_OS), Linux)
725LIB_OBJS += custom_baud_linux.o
726else
727LIB_OBJS += custom_baud.o
728endif
Carl-Daniel Hailfinger5bdf2982010-06-14 12:42:05 +0000729endif
730
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000731ifneq ($(NEED_POSIX_SOCKETS), )
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000732ifeq ($(TARGET_OS), SunOS)
Stefan Taunerfc3ecc22016-03-13 12:57:03 +0000733LIBS += -lsocket -lnsl
Carl-Daniel Hailfinger5cca01f2009-11-24 00:20:03 +0000734endif
Carl-Daniel Hailfingere51ea102009-11-23 19:20:11 +0000735endif
736
Nico Huberf55ca202021-06-27 14:36:06 +0200737NEED_LIBPCI := $(call filter_deps,$(DEPENDS_ON_LIBPCI))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000738ifneq ($(NEED_LIBPCI), )
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000739CHECK_LIBPCI = yes
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000740# This is a dirty hack, but it saves us from checking all PCI drivers and all platforms manually.
741# libpci may need raw memory, MSR or PCI port I/O on some platforms.
742# Individual drivers might have the same needs as well.
743NEED_RAW_ACCESS += $(NEED_LIBPCI)
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000744FEATURE_CFLAGS += -D'NEED_PCI=1'
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000745FEATURE_CFLAGS += $(call debug_shell,grep -q "OLD_PCI_GET_DEV := yes" .libdeps && printf "%s" "-D'OLD_PCI_GET_DEV=1'")
Stefan Tauner56734502015-02-08 21:58:04 +0000746
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000747PROGRAMMER_OBJS += pcidev.o
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000748ifeq ($(TARGET_OS), NetBSD)
Carl-Daniel Hailfinger460b2822010-06-04 23:24:57 +0000749# The libpci we want is called libpciutils on NetBSD and needs NetBSD libpci.
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000750PCILIBS += -lpciutils -lpci
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000751else
752PCILIBS += -lpci
753endif
754endif
755
756ifneq ($(NEED_RAW_ACCESS), )
757# Raw memory, MSR or PCI port I/O access.
758FEATURE_CFLAGS += -D'NEED_RAW_ACCESS=1'
759PROGRAMMER_OBJS += physmap.o hwaccess.o
760
761ifeq ($(TARGET_OS), NetBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200762ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000763PCILIBS += -l$(shell uname -p)
Nico Huber9245b882021-04-18 20:50:32 +0200764endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000765else
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +0000766ifeq ($(TARGET_OS), OpenBSD)
Nico Huber9245b882021-04-18 20:50:32 +0200767ifeq ($(ARCH), x86)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000768PCILIBS += -l$(shell uname -m)
Nico Huber9245b882021-04-18 20:50:32 +0200769endif
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000770else
771ifeq ($(TARGET_OS), Darwin)
772# DirectHW framework can be found in the DirectHW library.
Stefan Taunere34e3e82013-01-01 00:06:51 +0000773PCILIBS += -framework IOKit -framework DirectHW
Carl-Daniel Hailfingerb63b0672010-07-02 17:12:50 +0000774endif
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000775endif
Jonathan A. Kollasch3646c8f2010-01-08 21:18:08 +0000776endif
Carl-Daniel Hailfinger16c0aec2016-02-20 21:43:56 +0000777
Carl-Daniel Hailfinger66ef4e52009-12-13 22:28:00 +0000778endif
779
Nico Huberf55ca202021-06-27 14:36:06 +0200780NEED_LIBUSB1 := $(call filter_deps,$(DEPENDS_ON_LIBUSB1))
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000781ifneq ($(NEED_LIBUSB1), )
Stefan Taunere49edbb2016-01-31 22:10:14 +0000782CHECK_LIBUSB1 = yes
Daniel Thompson1d507a02018-07-12 11:02:28 +0100783PROGRAMMER_OBJS += usbdev.o
Stefan Taunere49edbb2016-01-31 22:10:14 +0000784# FreeBSD and DragonflyBSD use a reimplementation of libusb-1.0 that is simply called libusb
Thomas Heijligen485d2cd2021-10-19 16:14:55 +0200785ifeq ($(TARGET_OS), $(filter $(TARGET_OS), FreeBSD DragonFlyBSD))
Stefan Taunere49edbb2016-01-31 22:10:14 +0000786USB1LIBS += -lusb
787else
788ifeq ($(TARGET_OS),NetBSD)
Stefan Tauner45207062016-02-19 08:17:24 +0000789override CPPFLAGS += -I/usr/pkg/include/libusb-1.0
Stefan Taunere49edbb2016-01-31 22:10:14 +0000790USB1LIBS += -lusb-1.0
791else
Stefan Tauner45207062016-02-19 08:17:24 +0000792USB1LIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libusb-1.0 || printf "%s" "-lusb-1.0")
793override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libusb-1.0 || printf "%s" "-I/usr/include/libusb-1.0")
Stefan Taunere49edbb2016-01-31 22:10:14 +0000794endif
795endif
796endif
797
Nico Huberf55ca202021-06-27 14:36:06 +0200798NEED_LIBFTDI := $(call filter_deps,$(DEPENDS_ON_LIBFTDI))
Nico Huber09e82e22021-06-27 14:31:37 +0200799ifneq ($(NEED_LIBFTDI), )
800FTDILIBS := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --libs libftdi1 || $(PKG_CONFIG) --libs libftdi || printf "%s" "-lftdi -lusb")
801FEATURE_CFLAGS += $(call debug_shell,grep -q "FT232H := yes" .features && printf "%s" "-D'HAVE_FT232H=1'")
802FTDI_INCLUDES := $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)" ; $(PKG_CONFIG) --cflags-only-I libftdi1)
803FEATURE_CFLAGS += $(FTDI_INCLUDES)
804FEATURE_LIBS += $(call debug_shell,grep -q "FTDISUPPORT := yes" .features && printf "%s" "$(FTDILIBS)")
805# We can't set NEED_LIBUSB1 here because that would transform libftdi auto-enabling
806# into a hard requirement for libusb, defeating the purpose of auto-enabling.
807endif
808
Nico Huberf55ca202021-06-27 14:36:06 +0200809NEED_LIBJAYLINK := $(call filter_deps,$(DEPENDS_ON_LIBJAYLINK))
Marc Schink3578ec62016-03-17 16:23:03 +0100810ifneq ($(NEED_LIBJAYLINK), )
811CHECK_LIBJAYLINK = yes
812JAYLINKLIBS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --libs libjaylink)
813override CPPFLAGS += $(call debug_shell,[ -n "$(PKG_CONFIG_LIBDIR)" ] && export PKG_CONFIG_LIBDIR="$(PKG_CONFIG_LIBDIR)"; $(PKG_CONFIG) --cflags-only-I libjaylink)
814endif
815
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000816ifeq ($(CONFIG_PRINT_WIKI), yes)
Carl-Daniel Hailfinger71127722010-05-31 15:27:27 +0000817FEATURE_CFLAGS += -D'CONFIG_PRINT_WIKI=1'
Sean Nelson5d134642009-12-24 16:54:21 +0000818CLI_OBJS += print_wiki.o
Carl-Daniel Hailfinger9c8476b2009-09-16 12:19:03 +0000819endif
820
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000821FEATURE_CFLAGS += $(call debug_shell,grep -q "UTSNAME := yes" .features && printf "%s" "-D'HAVE_UTSNAME=1'")
Carl-Daniel Hailfinger132e2ec2010-03-27 16:36:40 +0000822
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000823# We could use PULLED_IN_LIBS, but that would be ugly.
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000824FEATURE_LIBS += $(call debug_shell,grep -q "NEEDLIBZ := yes" .libdeps && printf "%s" "-lz")
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000825
Nico Huber8624e8c2012-11-05 21:46:33 +0100826FEATURE_CFLAGS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-D'HAVE_CLOCK_GETTIME=1'")
827FEATURE_LIBS += $(call debug_shell,grep -q "CLOCK_GETTIME := yes" .features && printf "%s" "-lrt")
828
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000829LIBFLASHROM_OBJS = $(CHIP_OBJS) $(PROGRAMMER_OBJS) $(LIB_OBJS)
Stefan Taunerd94d25d2012-07-28 03:17:15 +0000830OBJS = $(CLI_OBJS) $(LIBFLASHROM_OBJS)
Sean Nelson5d134642009-12-24 16:54:21 +0000831
Joerg Mayera93d9dc2013-08-29 00:38:19 +0000832all: hwlibs features $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000833ifeq ($(ARCH), x86)
Thomas Heijligen3976b7e2021-10-20 15:55:35 +0200834 @+$(MAKE) -C util/ich_descriptors_tool/ HOST_OS=$(HOST_OS) TARGET_OS=$(TARGET_OS)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000835endif
836
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000837$(PROGRAM)$(EXEC_SUFFIX): $(OBJS)
Miklós Márton2d20d6d2018-01-30 20:20:15 +0100838 $(CC) $(LDFLAGS) -o $(PROGRAM)$(EXEC_SUFFIX) $(OBJS) $(LIBS) $(PCILIBS) $(FEATURE_LIBS) $(USBLIBS) $(USB1LIBS) $(JAYLINKLIBS) $(NI845X_LIBS)
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000839
Patrick Georgi97bc95c2011-03-08 07:17:44 +0000840libflashrom.a: $(LIBFLASHROM_OBJS)
841 $(AR) rcs $@ $^
842 $(RANLIB) $@
843
Carl-Daniel Hailfinger8ef7dce2009-07-10 20:19:48 +0000844# TAROPTIONS reduces information leakage from the packager's system.
845# If other tar programs support command line arguments for setting uid/gid of
846# stored files, they can be handled here as well.
847TAROPTIONS = $(shell LC_ALL=C tar --version|grep -q GNU && echo "--owner=root --group=root")
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000848
Paul Fox05dfbe62009-06-16 21:08:06 +0000849%.o: %.c .features
Stefan Tauner76347082016-11-27 17:45:49 +0100850 $(CC) -MMD $(CFLAGS) $(CPPFLAGS) $(FLASHROM_CFLAGS) $(FEATURE_CFLAGS) $(SCMDEF) -o $@ -c $<
Clark Rawlins02016f72008-02-14 23:22:20 +0000851
Carl-Daniel Hailfingera0020df2010-05-30 22:35:14 +0000852# Make sure to add all names of generated binaries here.
853# This includes all frontends and libflashrom.
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000854# We don't use EXEC_SUFFIX here because we want to clean everything.
Ronald G. Minnich5e5f75e2002-01-29 18:21:41 +0000855clean:
Thomas Heijligen1e76dc82021-09-28 15:22:34 +0200856 rm -f $(PROGRAM) $(PROGRAM).exe libflashrom.a $(filter-out Makefile.d, $(wildcard *.d *.o)) $(PROGRAM).8 $(PROGRAM).8.html $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000857 @+$(MAKE) -C util/ich_descriptors_tool/ clean
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000858
Ollie Lho184a4042005-11-26 21:55:36 +0000859distclean: clean
Stefan Reinauere2f01582010-06-07 11:08:07 +0000860 rm -f .features .libdeps
Christian Ruppertdb9d9f42009-05-14 14:17:07 +0000861
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000862strip: $(PROGRAM)$(EXEC_SUFFIX)
863 $(STRIP) $(STRIP_ARGS) $(PROGRAM)$(EXEC_SUFFIX)
Ronald G. Minnicheaab50b2003-09-12 22:41:53 +0000864
Stefan Tauner56787082011-08-18 02:27:19 +0000865# to define test programs we use verbatim variables, which get exported
866# to environment variables and are referenced with $$<varname> later
867
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000868compiler: featuresavailable
Thomas Heijligen323ad352021-10-26 11:26:32 +0200869 @echo -n "C compiler found: "
870 @if [ $(CC_WORKING) = yes ]; \
871 then $(CC) --version 2>/dev/null | head -1; \
872 else echo no; echo Aborting.; exit 1; fi
Thomas Heijligen8cd366d2021-10-26 12:02:52 +0200873 @echo "Target arch: $(ARCH)"
Thomas Heijligen6efdfb32021-10-12 15:16:46 +0200874 @if [ $(ARCH) = unknown ]; then echo Aborting.; exit 1; fi
Thomas Heijligen8cd366d2021-10-26 12:02:52 +0200875 @echo "Target OS: $(TARGET_OS)"
Thomas Heijligen1e76dc82021-09-28 15:22:34 +0200876 @if [ $(TARGET_OS) = unknown ]; then echo Aborting.; exit 1; fi
Thomas Heijligen8cd366d2021-10-26 12:02:52 +0200877 @if [ $(TARGET_OS) = libpayload ] && ! $(CC) --version 2>&1 | grep -q coreboot; then \
878 echo " Warning: It seems you are not using coreboot's reference compiler."; \
879 echo " This might work but usually does not, please beware."; fi
880 @echo "Target endian: $(ENDIAN)"
Thomas Heijligen9a2787b2021-10-12 15:54:06 +0200881 @if [ $(ENDIAN) = unknown ]; then echo Aborting.; exit 1; fi
Carl-Daniel Hailfinger4cb7a962009-06-16 09:31:51 +0000882
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000883hwlibs: compiler
884 @printf "" > .libdeps
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +0000885ifeq ($(CHECK_LIBPCI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000886 @printf "Checking for libpci headers... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000887 @echo "$$LIBPCI_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000888 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000889 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
890 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000891 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000892 echo "Please install libpci headers or disable all features"; \
893 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000894 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000895 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
896 @printf "Checking version of pci_get_dev... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56734502015-02-08 21:58:04 +0000897 @echo "$$PCI_GET_DEV_TEST" > .test.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000898 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000899 @ { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
Stefan Tauner56734502015-02-08 21:58:04 +0000900 ( echo "new version (including PCI domain parameter)."; echo "OLD_PCI_GET_DEV := no" >> .libdeps ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000901 ( echo "old version (without PCI domain parameter)."; echo "OLD_PCI_GET_DEV := yes" >> .libdeps ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
902 @printf "Checking if libpci is present and sufficient... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000903 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000904 @{ { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) 2>>$(BUILD_DETAILS_FILE) >&2 && \
905 echo "yes." || { echo "no."; \
906 printf "Checking if libz+libpci are present and sufficient..." ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000907 { printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz" >>$(BUILD_DETAILS_FILE) ; \
908 $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(PCILIBS) -lz >&2 && \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000909 echo "yes." && echo "NEEDLIBZ := yes" > .libdeps } || { echo "no."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000910 echo "The following features require libpci: $(NEED_LIBPCI)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000911 echo "Please install libpci (package pciutils) and/or libz or disable all features"; \
912 echo "mentioned above by specifying make CONFIG_ENABLE_LIBPCI_PROGRAMMERS=no"; \
Carl-Daniel Hailfingera472b8b2009-10-03 17:08:02 +0000913 echo "See README for more information."; echo; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000914 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +0000915 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
Carl-Daniel Hailfingere7a39bf2012-11-20 21:06:16 +0000916endif
Stefan Taunere49edbb2016-01-31 22:10:14 +0000917ifeq ($(CHECK_LIBUSB1), yes)
918 @printf "Checking for libusb-1.0 headers... " | tee -a $(BUILD_DETAILS_FILE)
919 @echo "$$LIBUSB1_TEST" > .test.c
920 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
921 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
922 echo "found." || { echo "not found."; echo; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000923 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000924 echo "Please install libusb-1.0 headers or disable all features"; \
925 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +0000926 echo "See README for more information."; echo; \
927 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
928 @printf "Checking if libusb-1.0 is usable... " | tee -a $(BUILD_DETAILS_FILE)
929 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS)" >>$(BUILD_DETAILS_FILE)
930 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(USB1LIBS) >&2 && \
931 echo "yes." || { echo "no."; \
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000932 echo "The following features require libusb-1.0: $(NEED_LIBUSB1)."; \
Carl-Daniel Hailfinger4b2b3152016-02-20 22:28:16 +0000933 echo "Please install libusb-1.0 or disable all features"; \
934 echo "mentioned above by specifying make CONFIG_ENABLE_LIBUSB1_PROGRAMMERS=no"; \
Stefan Taunere49edbb2016-01-31 22:10:14 +0000935 echo "See README for more information."; echo; \
936 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
937 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
938endif
Marc Schink3578ec62016-03-17 16:23:03 +0100939ifeq ($(CHECK_LIBJAYLINK), yes)
940 @printf "Checking for libjaylink headers... " | tee -a $(BUILD_DETAILS_FILE)
941 @echo "$$LIBJAYLINK_TEST" > .test.c
942 @printf "\nexec: %s\n" "$(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o" >>$(BUILD_DETAILS_FILE)
943 @{ { { { { $(CC) -c $(CPPFLAGS) $(CFLAGS) .test.c -o .test.o >&2 && \
944 echo "found." || { echo "not found."; echo; \
945 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
946 echo "Please install libjaylink headers or disable the feature"; \
947 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
948 echo "See README for more information."; echo; \
949 rm -f .test.c .test.o; exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
950 @printf "Checking if libjaylink is usable... " | tee -a $(BUILD_DETAILS_FILE)
951 @printf "\nexec: %s\n" "$(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS)" >>$(BUILD_DETAILS_FILE)
952 @{ { { { { $(CC) $(LDFLAGS) .test.o -o .test$(EXEC_SUFFIX) $(LIBS) $(JAYLINKLIBS) >&2 && \
953 echo "yes." || { echo "no."; \
954 echo "The following feature requires libjaylink: $(NEED_LIBJAYLINK)."; \
955 echo "Please install libjaylink or disable the feature"; \
956 echo "mentioned above by specifying make CONFIG_JLINK_SPI=no"; \
957 echo "See README for more information."; echo; \
958 rm -f .test.c .test.o .test$(EXEC_SUFFIX); exit 1; }; } 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
959 @rm -f .test.c .test.o .test$(EXEC_SUFFIX)
960endif
Stefan Reinauer53e96252005-12-01 16:19:24 +0000961
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000962.features: features
963
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000964# If a user does not explicitly request a non-working feature, we should
965# silently disable it. However, if a non-working (does not compile) feature
966# is explicitly requested, we should bail out with a descriptive error message.
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000967# We also have to check that at least one programmer driver is enabled.
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000968featuresavailable:
Carl-Daniel Hailfinger60d9bd22012-08-09 23:34:41 +0000969ifeq ($(PROGRAMMER_OBJS),)
970 @echo "You have to enable at least one programmer driver!"
971 @false
972endif
973ifneq ($(UNSUPPORTED_FEATURES), )
Carl-Daniel Hailfinger5d3fcb92010-06-14 18:40:59 +0000974 @echo "The following features are unavailable on your machine: $(UNSUPPORTED_FEATURES)"
975 @false
976endif
977
Carl-Daniel Hailfingerb18ecbc2009-06-19 14:20:34 +0000978features: compiler
979 @echo "FEATURES := yes" > .features.tmp
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +0000980ifneq ($(NEED_LIBFTDI), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000981 @printf "Checking for FTDI support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +0000982 @echo "$$FTDI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000983 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000984 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
985 ( echo "found."; echo "FTDISUPPORT := yes" >> .features.tmp ; \
986 printf "Checking for FT232H support in libftdi... " ; \
987 echo "$$FTDI_232H_TEST" >> .featuretest.c ; \
Stefan Taunerc83ddc12016-01-24 22:37:10 +0000988 printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE) ; \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +0000989 { $(CC) $(CPPFLAGS) $(CFLAGS) $(FTDI_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(FTDILIBS) $(LIBS) >&2 && \
990 ( echo "found."; echo "FT232H := yes" >> .features.tmp ) || \
991 ( echo "not found."; echo "FT232H := no" >> .features.tmp ) } \
992 ) || \
993 ( echo "not found."; echo "FTDISUPPORT := no" >> .features.tmp ) } \
994 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Carl-Daniel Hailfinger8a59ff02009-12-24 03:33:11 +0000995endif
David Hendricksf9a30552015-05-23 20:30:30 -0700996ifeq ($(CONFIG_LINUX_MTD), yes)
997 @printf "Checking if Linux MTD headers are present... " | tee -a $(BUILD_DETAILS_FILE)
998 @echo "$$LINUX_MTD_TEST" > .featuretest.c
999 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1000 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1001 ( echo "yes."; echo "LINUX_MTD_SUPPORT := yes" >> .features.tmp ) || \
1002 ( echo "no."; echo "LINUX_MTD_SUPPORT := no" >> .features.tmp ) } \
1003 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1004endif
Stefan Tauner8868db32012-03-13 00:18:19 +00001005ifeq ($(CONFIG_LINUX_SPI), yes)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001006 @printf "Checking if Linux SPI headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001007 @echo "$$LINUX_SPI_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001008 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001009 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner8868db32012-03-13 00:18:19 +00001010 ( echo "yes."; echo "LINUX_SPI_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001011 ( echo "no."; echo "LINUX_SPI_SUPPORT := no" >> .features.tmp ) } \
1012 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner8868db32012-03-13 00:18:19 +00001013endif
Carl-Daniel Hailfingerf2daaca2016-02-17 22:25:12 +00001014ifneq ($(NEED_LINUX_I2C), )
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001015 @printf "Checking if Linux I2C headers are present... " | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001016 @echo "$$LINUX_I2C_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001017 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001018 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001019 ( echo "yes."; echo "LINUX_I2C_SUPPORT := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001020 ( echo "no."; echo "LINUX_I2C_SUPPORT := no" >> .features.tmp ) } \
1021 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Alexandre Boeglin80e64712014-12-20 20:25:19 +00001022endif
Miklós Márton2d20d6d2018-01-30 20:20:15 +01001023ifeq ($(CONFIG_NI845X_SPI), yes)
1024 @printf "Checking for NI USB-845x installation... " | tee -a $(BUILD_DETAILS_FILE)
1025 @echo "$$NI845X_TEST" > .featuretest.c
1026 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS)" >>$(BUILD_DETAILS_FILE)
1027
1028 @ { { { { { $(CC) $(CPPFLAGS) $(CFLAGS) $(NI845X_INCLUDES) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) $(NI845X_LIBS) $(LIBS) >&2 && \
1029 ( echo "yes."; echo "NI845X_SUPPORT := yes" >> .features.tmp ) || \
1030 { echo -e "\nUnable to find NI-845x headers or libraries."; \
1031 echo "Please pass the NI-845x library path to the make with the CONFIG_NI845X_LIBRARY_PATH parameter,"; \
1032 echo "or disable the NI-845x support by specifying make CONFIG_NI845X_SPI=no"; \
1033 echo "For the NI-845x 17.0 the library path is:"; \
1034 echo " On 32 bit systems: C:\Program Files)\National Instruments\NI-845x\MS Visual C"; \
1035 echo " On 64 bit systems: C:\Program Files (x86)\National Instruments\NI-845x\MS Visual C"; \
1036 exit 1; }; } \
1037 2>>$(BUILD_DETAILS_FILE); echo $? >&3 ; } | tee -a $(BUILD_DETAILS_FILE) >&4; } 3>&1;} | { read rc ; exit ${rc}; } } 4>&1
1038endif
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001039 @printf "Checking for utsname support... " | tee -a $(BUILD_DETAILS_FILE)
Stefan Tauner56787082011-08-18 02:27:19 +00001040 @echo "$$UTSNAME_TEST" > .featuretest.c
Stefan Taunerc83ddc12016-01-24 22:37:10 +00001041 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001042 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
Stefan Tauner56787082011-08-18 02:27:19 +00001043 ( echo "found."; echo "UTSNAME := yes" >> .features.tmp ) || \
Stefan Tauner3f73ffe2016-01-07 17:45:59 +00001044 ( echo "not found."; echo "UTSNAME := no" >> .features.tmp ) } 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Nico Huber8624e8c2012-11-05 21:46:33 +01001045 @printf "Checking for clock_gettime support... " | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001046ifeq ($(DISABLE_CLOCK_GETTIME), yes)
1047 @ { ( echo "disabled."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1048 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
1049else
Nico Huber8624e8c2012-11-05 21:46:33 +01001050 @echo "$$CLOCK_GETTIME_TEST" >.featuretest.c
1051 @printf "\nexec: %s\n" "$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX)" >>$(BUILD_DETAILS_FILE)
1052 @ { $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) -lrt .featuretest.c -o .featuretest$(EXEC_SUFFIX) >&2 && \
1053 ( echo "found."; echo "CLOCK_GETTIME := yes" >>.features.tmp ) || \
1054 ( echo "not found."; echo "CLOCK_GETTIME := no" >>.features.tmp ) } \
1055 2>>$(BUILD_DETAILS_FILE) | tee -a $(BUILD_DETAILS_FILE)
Martin Lucinac14e3f62020-12-18 14:11:04 +00001056endif
Stefan Tauner56787082011-08-18 02:27:19 +00001057 @$(DIFF) -q .features.tmp .features >/dev/null 2>&1 && rm .features.tmp || mv .features.tmp .features
1058 @rm -f .featuretest.c .featuretest$(EXEC_SUFFIX)
Paul Fox05dfbe62009-06-16 21:08:06 +00001059
Stefan Tauner4c723152016-01-14 22:47:55 +00001060$(PROGRAM).8.html: $(PROGRAM).8
1061 @groff -mandoc -Thtml $< >$@
1062
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001063$(PROGRAM).8: $(PROGRAM).8.tmpl
Stefan Tauner4c723152016-01-14 22:47:55 +00001064 @# Add the man page change date and version to the man page
Nico Huberac90af62022-12-18 00:22:47 +00001065 @sed -e 's#.TH FLASHROM 8 .*#.TH FLASHROM 8 "$(MAN_DATE)" "flashrom-stable-$(VERSION)" "$(MAN_DATE)"#' <$< >$@
Joerg Mayera93d9dc2013-08-29 00:38:19 +00001066
1067install: $(PROGRAM)$(EXEC_SUFFIX) $(PROGRAM).8
Uwe Hermannc2a9c9c2009-05-14 14:51:14 +00001068 mkdir -p $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001069 mkdir -p $(DESTDIR)$(MANDIR)/man8
Carl-Daniel Hailfingerddbab712010-06-14 14:44:08 +00001070 $(INSTALL) -m 0755 $(PROGRAM)$(EXEC_SUFFIX) $(DESTDIR)$(PREFIX)/sbin
Uwe Hermann56b2cb02009-05-21 15:59:58 +00001071 $(INSTALL) -m 0644 $(PROGRAM).8 $(DESTDIR)$(MANDIR)/man8
Uwe Hermannc113b572006-12-14 00:59:41 +00001072
Nico Huber454f6132012-12-10 13:34:10 +00001073libinstall: libflashrom.a libflashrom.h
1074 mkdir -p $(DESTDIR)$(PREFIX)/lib
1075 $(INSTALL) -m 0644 libflashrom.a $(DESTDIR)$(PREFIX)/lib
1076 mkdir -p $(DESTDIR)$(PREFIX)/include
1077 $(INSTALL) -m 0644 libflashrom.h $(DESTDIR)$(PREFIX)/include
1078
Nico Huber5f245a22023-01-10 17:14:47 +01001079versioninfo:
1080# Generate versioninfo.inc containing metadata that would not be available in exported sources otherwise.
1081 @[ "$(RELEASE)" ] || { echo 'Error: Must provide `RELEASE=...`'; exit 1; }
1082 @echo "VERSION = $(RELEASE)" > $@.inc
1083 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> $@.inc
1084
Nico Huber26c2c4d2023-01-10 17:45:38 +01001085branch: versioninfo
1086 @git checkout -b $(RELEASE)
1087 @git add -f $<.inc
1088 @git commit -sm'Update version info for $(RELEASE)'
1089
1090tag: versioninfo
1091 @git add -f $<.inc
1092 @git commit -sm'Update version info for $(RELEASE)'
1093 @git tag -s $(RELEASE)
1094
Nico Huber5f245a22023-01-10 17:14:47 +01001095# No spaces in release names unless set explicitly
Nico Huber1d58a902023-01-10 18:26:12 +01001096RELEASENAME ?= flashrom-stable-$(shell echo "$(VERSION)" | sed -e 's/ /_/')
Nico Huber5f245a22023-01-10 17:14:47 +01001097
Nico Huber1d58a902023-01-10 18:26:12 +01001098_export: EXPORT_VERSIONINFO := $(EXPORTDIR)/$(RELEASENAME)/versioninfo.inc
Stefan Tauner76347082016-11-27 17:45:49 +01001099_export: $(PROGRAM).8
Nico Huber1d58a902023-01-10 18:26:12 +01001100 @rm -rf "$(EXPORTDIR)/$(RELEASENAME)"
1101 @mkdir -p "$(EXPORTDIR)/$(RELEASENAME)"
1102 @git archive HEAD | tar -x -C "$(EXPORTDIR)/$(RELEASENAME)"
Nico Huber5f245a22023-01-10 17:14:47 +01001103# Generate fresh versioninfo.inc and compare
1104 @echo "VERSION = $(shell ./util/getrevision.sh --revision)" > "$(EXPORT_VERSIONINFO)"
1105 @echo "MAN_DATE = $(shell ./util/getrevision.sh --date $(PROGRAM).8.tmpl 2>/dev/null)" >> \
1106 "$(EXPORT_VERSIONINFO)"
1107 @if [ -f versioninfo.inc ]; then \
1108 cmp -s versioninfo.inc "$(EXPORT_VERSIONINFO)" || \
1109 { echo Error: Version info changed:; \
1110 cat "$(EXPORT_VERSIONINFO)"; \
1111 echo Update versioninfo.inc and tag accordingly.; \
1112 exit 1; \
1113 }; \
1114 fi
Stefan Taunere4136852017-10-01 15:57:25 +02001115# Restore modification date of all tracked files not marked 'export-ignore' in .gitattributes.
1116# sed is required to filter out file names having the attribute set.
1117# The sed program saves the file name in the hold buffer and then checks if the respective value is 'set'.
1118# If so it ignores the rest of the program, which otherwise restores the file name and prints it.
Stefan Tauner76347082016-11-27 17:45:49 +01001119 @git ls-tree -r -z -t --full-name --name-only HEAD | \
1120 git check-attr -z --stdin export-ignore | \
Stefan Taunere4136852017-10-01 15:57:25 +02001121 sed -zne 'x;n;n;{/^set$$/b;};x;p;' | \
Stefan Tauner76347082016-11-27 17:45:49 +01001122 xargs -0 sh -c 'for f; do \
1123 touch -d $$(git log --pretty=format:%cI -1 HEAD -- "$$f") \
Nico Huber1d58a902023-01-10 18:26:12 +01001124 "$(EXPORTDIR)/$(RELEASENAME)/$$f"; \
Stefan Taunere4136852017-10-01 15:57:25 +02001125 done' dummy_arg0
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001126
Stefan Tauner76347082016-11-27 17:45:49 +01001127export: _export
Nico Huber1d58a902023-01-10 18:26:12 +01001128 @echo "Exported $(EXPORTDIR)/$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001129
1130tarball: _export
Nico Huber1d58a902023-01-10 18:26:12 +01001131 @tar -cj --format=ustar -f "$(EXPORTDIR)/$(RELEASENAME).tar.bz2" -C $(EXPORTDIR)/ \
1132 $(TAROPTIONS) "$(RELEASENAME)/"
Stefan Tauner76347082016-11-27 17:45:49 +01001133# Delete the exported directory again because it is most likely what's expected by the user.
Nico Huber1d58a902023-01-10 18:26:12 +01001134 @rm -rf "$(EXPORTDIR)/$(RELEASENAME)"
1135 @echo Created "$(EXPORTDIR)/$(RELEASENAME).tar.bz2"
Carl-Daniel Hailfingera23041c2009-06-12 14:49:10 +00001136
Carl-Daniel Hailfinger33a65a02011-12-20 00:51:44 +00001137libpayload: clean
1138 make CC="CC=i386-elf-gcc lpgcc" AR=i386-elf-ar RANLIB=i386-elf-ranlib
Carl-Daniel Hailfinger50415d22010-03-21 14:54:57 +00001139
Felix Singer9441c6e2022-10-21 12:47:11 +02001140gitconfig:
1141 ./util/getrevision.sh -c 2>/dev/null && ./util/git-hooks/install.sh
1142
Nico Huber26c2c4d2023-01-10 17:45:38 +01001143.PHONY: all install clean distclean compiler hwlibs features branch tag versioninfo _export export tarball featuresavailable libpayload gitconfig
Ollie Lho184a4042005-11-26 21:55:36 +00001144
Stefan Tauner23e10b82016-01-23 16:16:49 +00001145# Disable implicit suffixes and built-in rules (for performance and profit)
1146.SUFFIXES:
1147
Stefan Reinauere2f01582010-06-07 11:08:07 +00001148-include $(OBJS:.o=.d)